
Ruby - Bug #19305

TracePoint#parameters segfaults when certain method creation pattern is used

01/03/2023 09:57 PM - st0012 (Stan Lo)

Status: Closed   

Priority: Normal   

Assignee:    

Target version:    

ruby -v: 3.2.0, 3.1.3 Backport: 2.7: DONTNEED, 3.0: DONTNEED, 3.1:

DONE, 3.2: DONE

Description

Reproduction Steps

1. Create a test.rb with:

class Foo

  attr_reader :bar

  alias_method :bar?, :bar

  remove_method :bar

end

f = Foo.new

TracePoint.trace(:a_call) do |tp|

  puts tp.method_id

  puts tp.parameters

end

f.bar?

1. Run ruby test.rb

2. Ruby would crash (an example crash report is attached below)

Implication

I learned this pattern from the bootsnap gem. It defines Bootsnap::LoadPathCache.enabled? this way, which is used to patch 

Kernel.require.

This means when users use bootsnap (likely a Rails app) with TracePoint#parameters (e.g. uses the debug gem's tracer), Ruby

would crash whenever require is called.

Crash Report

<internal:trace_point>:329: [BUG] Segmentation fault at 0x0000000000000010

ruby 3.2.0 (2022-12-25 revision a528908271) [arm64-darwin21.5.0]

-- Crash Report log information --------------------------------------------

   See Crash Report log file in one of the following locations:             

     * ~/Library/Logs/DiagnosticReports                                     

     * /Library/Logs/DiagnosticReports                                      

   for more details.                                                        

Don't forget to include the above Crash Report log file in bug reports.     

-- Control frame information -----------------------------------------------

c:0004 p:0003 s:0017 e:000016 METHOD <internal:trace_point>:329

c:0003 p:0013 s:0013 e:000011 BLOCK  test.rb:11 [FINISH]

c:0002 p:0026 s:0008 E:000af8 EVAL   test.rb:14 [FINISH]

c:0001 p:0000 s:0003 E:000a70 DUMMY  [FINISH]

-- Ruby level backtrace information ----------------------------------------

test.rb:14:in `<main>'
test.rb:11:in `block in <main>'

<internal:trace_point>:329:in `parameters'

-- Machine register context ------------------------------------------------

  x0: 0x0000000000000000  x1: 0x000000000000eef1  x2: 0x000000016dbc2000

  x3: 0x000000016dbc2050  x4: 0x0000000000000000  x5: 0x0000000000000000

  x6: 0x0000000000000072  x7: 0x0000000000000024 x18: 0x0000000000000000

 x19: 0x000000016dbc25c0 x20: 0x000000016dbc25f0 x21: 0x0000000148107f00

 x22: 0x0000000000eef10c x23: 0x0000000154060b10 x24: 0x0000000148107f40

 x25: 0x0000000102520fa0 x26: 0x000000015406db59 x27: 0x0000000146823798

 x28: 0x0000000152f06bd0  lr: 0x0000000102c3e354  fp: 0x000000016dbc2040

  sp: 0x000000016dbc2030

-- C level backtrace information -------------------------------------------

/opt/rubies/3.2.0/lib/libruby.3.2.dylib(rb_vm_bugreport+0x9a0) [0x102c3be20]

/opt/rubies/3.2.0/lib/libruby.3.2.dylib(rb_bug_for_fatal_signal+0x160) [0x102a60f1c]

/opt/rubies/3.2.0/lib/libruby.3.2.dylib(sig_do_nothing+0x0) [0x102b9a798]

/usr/lib/system/libsystem_platform.dylib(_sigtramp+0x38) [0x1966182a4]

/opt/rubies/3.2.0/lib/libruby.3.2.dylib(rb_tracearg_parameters+0x1a0) [0x102c3e354]

/opt/rubies/3.2.0/lib/libruby.3.2.dylib(rb_tracearg_parameters+0x1a0) [0x102c3e354]

/opt/rubies/3.2.0/lib/libruby.3.2.dylib(vm_exec_core+0x57b8) [0x102c16988]

/opt/rubies/3.2.0/lib/libruby.3.2.dylib(rb_vm_exec+0xb2c) [0x102c26d20]

/opt/rubies/3.2.0/lib/libruby.3.2.dylib(rb_vm_invoke_proc+0x4b0) [0x102c24a0c]

/opt/rubies/3.2.0/lib/libruby.3.2.dylib(rb_proc_call_with_block+0x58) [0x102b388ac]

/opt/rubies/3.2.0/lib/libruby.3.2.dylib(tp_call_trace+0xc0) [0x102c3ea04]

/opt/rubies/3.2.0/lib/libruby.3.2.dylib(exec_hooks_protected+0x168) [0x102c3da2c]

/opt/rubies/3.2.0/lib/libruby.3.2.dylib(rb_exec_event_hooks+0x80) [0x102c3d774]

/opt/rubies/3.2.0/lib/libruby.3.2.dylib(vm_call_method_each_type+0xad8) [0x102c2b970]

/opt/rubies/3.2.0/lib/libruby.3.2.dylib(vm_sendish+0x4c8) [0x102c32384]

/opt/rubies/3.2.0/lib/libruby.3.2.dylib(vm_exec_core+0x24f0) [0x102c136c0]

/opt/rubies/3.2.0/lib/libruby.3.2.dylib(rb_vm_exec+0xb2c) [0x102c26d20]

/opt/rubies/3.2.0/lib/libruby.3.2.dylib(rb_ec_exec_node+0x12c) [0x102a6c5b0]

/opt/rubies/3.2.0/lib/libruby.3.2.dylib(ruby_run_node+0x60) [0x102a6c41c]

/opt/rubies/3.2.0/bin/ruby(main+0x68) [0x10223ff34]

-- Other runtime information -----------------------------------------------

* Loaded script: test.rb

* Loaded features:

    0 enumerator.so

    1 thread.rb

    2 fiber.so

    3 rational.so

    4 complex.so

    5 ruby2_keywords.rb

    6 /opt/rubies/3.2.0/lib/ruby/3.2.0/arm64-darwin21.5.0/enc/encdb.bundle

    7 /opt/rubies/3.2.0/lib/ruby/3.2.0/arm64-darwin21.5.0/enc/trans/transdb.bundle

    8 /opt/rubies/3.2.0/lib/ruby/3.2.0/arm64-darwin21.5.0/rbconfig.rb

    9 /opt/rubies/3.2.0/lib/ruby/3.2.0/rubygems/compatibility.rb

   10 /opt/rubies/3.2.0/lib/ruby/3.2.0/rubygems/defaults.rb

   11 /opt/rubies/3.2.0/lib/ruby/3.2.0/rubygems/deprecate.rb

   12 /opt/rubies/3.2.0/lib/ruby/3.2.0/rubygems/errors.rb

   13 /opt/rubies/3.2.0/lib/ruby/3.2.0/rubygems/unknown_command_spell_checker.rb

   14 /opt/rubies/3.2.0/lib/ruby/3.2.0/rubygems/exceptions.rb

   15 /opt/rubies/3.2.0/lib/ruby/3.2.0/rubygems/basic_specification.rb

   16 /opt/rubies/3.2.0/lib/ruby/3.2.0/rubygems/stub_specification.rb

   17 /opt/rubies/3.2.0/lib/ruby/3.2.0/rubygems/platform.rb

   18 /opt/rubies/3.2.0/lib/ruby/3.2.0/rubygems/util/list.rb

   19 /opt/rubies/3.2.0/lib/ruby/3.2.0/rubygems/version.rb

   20 /opt/rubies/3.2.0/lib/ruby/3.2.0/rubygems/requirement.rb

   21 /opt/rubies/3.2.0/lib/ruby/3.2.0/rubygems/specification.rb

   22 /opt/rubies/3.2.0/lib/ruby/3.2.0/rubygems/util.rb

   23 /opt/rubies/3.2.0/lib/ruby/3.2.0/rubygems/dependency.rb

   24 /opt/rubies/3.2.0/lib/ruby/3.2.0/rubygems/core_ext/kernel_gem.rb

   25 /opt/rubies/3.2.0/lib/ruby/3.2.0/arm64-darwin21.5.0/monitor.bundle
   26 /opt/rubies/3.2.0/lib/ruby/3.2.0/monitor.rb

   27 /opt/rubies/3.2.0/lib/ruby/3.2.0/rubygems/core_ext/kernel_require.rb

   28 /opt/rubies/3.2.0/lib/ruby/3.2.0/rubygems/core_ext/kernel_warn.rb

   29 /opt/rubies/3.2.0/lib/ruby/3.2.0/rubygems.rb

   30 /opt/rubies/3.2.0/lib/ruby/3.2.0/rubygems/path_support.rb

   31 /opt/rubies/3.2.0/lib/ruby/3.2.0/error_highlight/version.rb

   32 /opt/rubies/3.2.0/lib/ruby/3.2.0/error_highlight/base.rb

   33 /opt/rubies/3.2.0/lib/ruby/3.2.0/error_highlight/formatter.rb

   34 /opt/rubies/3.2.0/lib/ruby/3.2.0/error_highlight/core_ext.rb

   35 /opt/rubies/3.2.0/lib/ruby/3.2.0/error_highlight.rb

   36 /opt/rubies/3.2.0/lib/ruby/3.2.0/did_you_mean/version.rb

   37 /opt/rubies/3.2.0/lib/ruby/3.2.0/did_you_mean/core_ext/name_error.rb

   38 /opt/rubies/3.2.0/lib/ruby/3.2.0/did_you_mean/levenshtein.rb

   39 /opt/rubies/3.2.0/lib/ruby/3.2.0/did_you_mean/jaro_winkler.rb

   40 /opt/rubies/3.2.0/lib/ruby/3.2.0/did_you_mean/spell_checker.rb

   41 /opt/rubies/3.2.0/lib/ruby/3.2.0/did_you_mean/spell_checkers/name_error_checkers/class_name_

checker.rb

   42 /opt/rubies/3.2.0/lib/ruby/3.2.0/did_you_mean/spell_checkers/name_error_checkers/variable_na

me_checker.rb

   43 /opt/rubies/3.2.0/lib/ruby/3.2.0/did_you_mean/spell_checkers/name_error_checkers.rb

   44 /opt/rubies/3.2.0/lib/ruby/3.2.0/did_you_mean/spell_checkers/method_name_checker.rb

   45 /opt/rubies/3.2.0/lib/ruby/3.2.0/did_you_mean/spell_checkers/key_error_checker.rb

   46 /opt/rubies/3.2.0/lib/ruby/3.2.0/did_you_mean/spell_checkers/null_checker.rb

   47 /opt/rubies/3.2.0/lib/ruby/3.2.0/did_you_mean/tree_spell_checker.rb

   48 /opt/rubies/3.2.0/lib/ruby/3.2.0/did_you_mean/spell_checkers/require_path_checker.rb

   49 /opt/rubies/3.2.0/lib/ruby/3.2.0/did_you_mean/spell_checkers/pattern_key_name_checker.rb

   50 /opt/rubies/3.2.0/lib/ruby/3.2.0/did_you_mean/formatter.rb

   51 /opt/rubies/3.2.0/lib/ruby/3.2.0/did_you_mean.rb

   52 /opt/rubies/3.2.0/lib/ruby/3.2.0/syntax_suggest/core_ext.rb

* Process memory map:

10223c000-102240000 r-x /opt/rubies/3.2.0/bin/ruby

102240000-102244000 r-- /opt/rubies/3.2.0/bin/ruby

102244000-102248000 r-- /opt/rubies/3.2.0/bin/ruby

102248000-102288000 r-- /opt/rubies/3.2.0/bin/ruby

102288000-10228c000 r-- /opt/rubies/3.2.0/bin/ruby

102290000-1022a0000 rw- /opt/rubies/3.2.0/bin/ruby

1022a0000-1022ac000 r-- /opt/rubies/3.2.0/bin/ruby

1022b0000-1022c0000 rw- /opt/rubies/3.2.0/lib/ruby/3.2.0/arm64-darwin21.5.0/enc/encdb.bundle

1022c8000-1022d0000 rw- /opt/rubies/3.2.0/lib/ruby/3.2.0/arm64-darwin21.5.0/enc/encdb.bundle

1022d0000-1022d4000 r-- /opt/rubies/3.2.0/lib/ruby/3.2.0/arm64-darwin21.5.0/enc/encdb.bundle

1022d4000-1022d8000 r-- /opt/rubies/3.2.0/lib/ruby/3.2.0/arm64-darwin21.5.0/enc/encdb.bundle

1022d8000-1022dc000 rw- /opt/rubies/3.2.0/lib/ruby/3.2.0/arm64-darwin21.5.0/enc/encdb.bundle

1022dc000-1022e0000 --- /opt/rubies/3.2.0/lib/ruby/3.2.0/arm64-darwin21.5.0/enc/encdb.bundle

1022e0000-1022e8000 rw- /opt/rubies/3.2.0/lib/ruby/3.2.0/arm64-darwin21.5.0/enc/encdb.bundle

1022e8000-1022ec000 --- /opt/rubies/3.2.0/lib/ruby/3.2.0/arm64-darwin21.5.0/enc/encdb.bundle

1022ec000-1022f0000 --- /opt/rubies/3.2.0/lib/ruby/3.2.0/arm64-darwin21.5.0/enc/encdb.bundle

1022f0000-1022f8000 rw- /opt/rubies/3.2.0/lib/ruby/3.2.0/arm64-darwin21.5.0/enc/encdb.bundle

1022f8000-1022fc000 --- /opt/rubies/3.2.0/lib/ruby/3.2.0/arm64-darwin21.5.0/enc/encdb.bundle

1022fc000-102300000 --- /opt/rubies/3.2.0/lib/ruby/3.2.0/arm64-darwin21.5.0/enc/encdb.bundle

102300000-102308000 rw- /opt/rubies/3.2.0/lib/ruby/3.2.0/arm64-darwin21.5.0/enc/encdb.bundle

102308000-10230c000 --- /opt/rubies/3.2.0/lib/ruby/3.2.0/arm64-darwin21.5.0/enc/encdb.bundle

10230c000-102310000 r-- /opt/rubies/3.2.0/lib/ruby/3.2.0/arm64-darwin21.5.0/enc/encdb.bundle

102310000-102314000 r-x /opt/rubies/3.2.0/lib/ruby/3.2.0/arm64-darwin21.5.0/enc/encdb.bundle

102314000-102318000 r-- /opt/rubies/3.2.0/lib/ruby/3.2.0/arm64-darwin21.5.0/enc/encdb.bundle

102318000-10231c000 r-- /opt/rubies/3.2.0/lib/ruby/3.2.0/arm64-darwin21.5.0/enc/encdb.bundle

102320000-102330000 rw- /opt/rubies/3.2.0/lib/ruby/3.2.0/arm64-darwin21.5.0/enc/trans/transdb.bund

le

102330000-102334000 r-x /opt/rubies/3.2.0/lib/ruby/3.2.0/arm64-darwin21.5.0/enc/trans/transdb.bund

le

102334000-102338000 r-- /opt/rubies/3.2.0/lib/ruby/3.2.0/arm64-darwin21.5.0/enc/trans/transdb.bund

le

102338000-10233c000 r-- /opt/rubies/3.2.0/lib/ruby/3.2.0/arm64-darwin21.5.0/enc/trans/transdb.bund

le

102340000-102350000 rw- /opt/rubies/3.2.0/lib/ruby/3.2.0/arm64-darwin21.5.0/monitor.bundle

102350000-102354000 r-x /opt/rubies/3.2.0/lib/ruby/3.2.0/arm64-darwin21.5.0/monitor.bundle
102354000-102358000 r-- /opt/rubies/3.2.0/lib/ruby/3.2.0/arm64-darwin21.5.0/monitor.bundle

102358000-10235c000 rw- /opt/rubies/3.2.0/lib/ruby/3.2.0/arm64-darwin21.5.0/monitor.bundle

10235c000-102360000 r-- /opt/rubies/3.2.0/lib/ruby/3.2.0/arm64-darwin21.5.0/monitor.bundle

102360000-102370000 rw- /usr/lib/system/libsystem_platform.dylib

102380000-102390000 rw- /usr/lib/system/libsystem_platform.dylib

1023a0000-1023b0000 rw- /usr/lib/system/libsystem_platform.dylib

1023c0000-1023d0000 rw- /usr/lib/system/libsystem_platform.dylib

1023e0000-1023f0000 rw- /usr/lib/system/libsystem_platform.dylib

102400000-102410000 rw- /usr/lib/system/libsystem_platform.dylib

102420000-102430000 rw- /usr/lib/system/libsystem_platform.dylib

102440000-102450000 rw- /usr/lib/system/libsystem_platform.dylib

102460000-102470000 rw- /usr/lib/system/libsystem_platform.dylib

102480000-102490000 rw- /usr/lib/system/libsystem_platform.dylib

1024a0000-1024b0000 rw- /usr/lib/system/libsystem_platform.dylib

1024c0000-1024d0000 rw- /usr/lib/system/libsystem_platform.dylib

1024e0000-1024f0000 rw- /usr/lib/system/libsystem_platform.dylib

102500000-102510000 rw- /usr/lib/system/libsystem_platform.dylib

102520000-102530000 rw- /usr/lib/system/libsystem_platform.dylib

102540000-102550000 rw- /usr/lib/system/libsystem_platform.dylib

102560000-102570000 rw- /usr/lib/system/libsystem_platform.dylib

102580000-102590000 rw- /usr/lib/system/libsystem_platform.dylib

1025a0000-1025b0000 rw- /usr/lib/system/libsystem_platform.dylib

1025c0000-1025d0000 rw- /usr/lib/system/libsystem_platform.dylib

1025e0000-1025f0000 rw- /usr/lib/system/libsystem_platform.dylib

102600000-102610000 rw- /usr/lib/system/libsystem_platform.dylib

102620000-102630000 rw- /usr/lib/system/libsystem_platform.dylib

102640000-102650000 rw- /usr/lib/system/libsystem_platform.dylib

102650000-1026d0000 r-- /usr/lib/system/libsystem_platform.dylib

1029c8000-102e7c000 r-x /opt/rubies/3.2.0/lib/libruby.3.2.dylib

102e7c000-102e98000 r-- /opt/rubies/3.2.0/lib/libruby.3.2.dylib

102e98000-102e9c000 rw- /opt/rubies/3.2.0/lib/libruby.3.2.dylib

102e9c000-102eac000 rw- /opt/rubies/3.2.0/lib/libruby.3.2.dylib

102eac000-1030d8000 r-- /opt/rubies/3.2.0/lib/libruby.3.2.dylib

1030d8000-1040d8000 rw- /opt/rubies/3.2.0/lib/libruby.3.2.dylib

1040d8000-1040dc000 --- /opt/rubies/3.2.0/lib/libruby.3.2.dylib

1040dc000-104180000 rw- /opt/rubies/3.2.0/lib/libruby.3.2.dylib

104180000-104184000 --- /opt/rubies/3.2.0/lib/libruby.3.2.dylib

104184000-104228000 rw- /opt/rubies/3.2.0/lib/libruby.3.2.dylib

104228000-10422c000 --- /opt/rubies/3.2.0/lib/libruby.3.2.dylib

10422c000-1042d0000 rw- /opt/rubies/3.2.0/lib/libruby.3.2.dylib

1042d0000-1042d4000 --- /opt/rubies/3.2.0/lib/libruby.3.2.dylib

1042d4000-104378000 rw- /opt/rubies/3.2.0/lib/libruby.3.2.dylib

104378000-10437c000 --- /opt/rubies/3.2.0/lib/libruby.3.2.dylib

10437c000-104420000 rw- /opt/rubies/3.2.0/lib/libruby.3.2.dylib

104420000-104424000 --- /opt/rubies/3.2.0/lib/libruby.3.2.dylib

104424000-1044c8000 rw- /opt/rubies/3.2.0/lib/libruby.3.2.dylib

1044c8000-1044cc000 --- /opt/rubies/3.2.0/lib/libruby.3.2.dylib

1044cc000-104570000 rw- /opt/rubies/3.2.0/lib/libruby.3.2.dylib

104570000-104574000 --- /opt/rubies/3.2.0/lib/libruby.3.2.dylib

104574000-104618000 rw- /opt/rubies/3.2.0/lib/libruby.3.2.dylib

104618000-10461c000 --- /opt/rubies/3.2.0/lib/libruby.3.2.dylib

10461c000-1046c0000 rw- /opt/rubies/3.2.0/lib/libruby.3.2.dylib

1046c0000-1046c4000 --- /opt/rubies/3.2.0/lib/libruby.3.2.dylib

1046c4000-104768000 rw- /opt/rubies/3.2.0/lib/libruby.3.2.dylib

104768000-10476c000 --- /opt/rubies/3.2.0/lib/libruby.3.2.dylib

10476c000-104810000 rw- /opt/rubies/3.2.0/lib/libruby.3.2.dylib

104810000-104814000 --- /opt/rubies/3.2.0/lib/libruby.3.2.dylib

104814000-1048b8000 rw- /opt/rubies/3.2.0/lib/libruby.3.2.dylib

1048b8000-1048bc000 --- /opt/rubies/3.2.0/lib/libruby.3.2.dylib

1048bc000-104960000 rw- /opt/rubies/3.2.0/lib/libruby.3.2.dylib

104960000-104964000 --- /opt/rubies/3.2.0/lib/libruby.3.2.dylib

104964000-104a08000 rw- /opt/rubies/3.2.0/lib/libruby.3.2.dylib

104a08000-104a0c000 --- /opt/rubies/3.2.0/lib/libruby.3.2.dylib

104a0c000-104ab0000 rw- /opt/rubies/3.2.0/lib/libruby.3.2.dylib

104ab0000-104ab4000 --- /opt/rubies/3.2.0/lib/libruby.3.2.dylib

104ab4000-104b58000 rw- /opt/rubies/3.2.0/lib/libruby.3.2.dylib

104b58000-104b5c000 --- /opt/rubies/3.2.0/lib/libruby.3.2.dylib
104b5c000-104c00000 rw- /opt/rubies/3.2.0/lib/libruby.3.2.dylib

104c00000-104c04000 --- /opt/rubies/3.2.0/lib/libruby.3.2.dylib

104c04000-104ca8000 rw- /opt/rubies/3.2.0/lib/libruby.3.2.dylib

104ca8000-104cac000 --- /opt/rubies/3.2.0/lib/libruby.3.2.dylib

104cac000-104d50000 rw- /opt/rubies/3.2.0/lib/libruby.3.2.dylib

104d50000-104d54000 --- /opt/rubies/3.2.0/lib/libruby.3.2.dylib

104d54000-104df8000 rw- /opt/rubies/3.2.0/lib/libruby.3.2.dylib

104df8000-104dfc000 --- /opt/rubies/3.2.0/lib/libruby.3.2.dylib

104dfc000-104ea0000 rw- /opt/rubies/3.2.0/lib/libruby.3.2.dylib

104ea0000-104ea4000 --- /opt/rubies/3.2.0/lib/libruby.3.2.dylib

104ea4000-104f48000 rw- /opt/rubies/3.2.0/lib/libruby.3.2.dylib

104f48000-104f4c000 --- /opt/rubies/3.2.0/lib/libruby.3.2.dylib

104f4c000-104ff0000 rw- /opt/rubies/3.2.0/lib/libruby.3.2.dylib

104ff0000-104ff4000 --- /opt/rubies/3.2.0/lib/libruby.3.2.dylib

104ff4000-105098000 rw- /opt/rubies/3.2.0/lib/libruby.3.2.dylib

105098000-10509c000 --- /opt/rubies/3.2.0/lib/libruby.3.2.dylib

10509c000-105140000 rw- /opt/rubies/3.2.0/lib/libruby.3.2.dylib

105140000-105144000 --- /opt/rubies/3.2.0/lib/libruby.3.2.dylib

105144000-1051e8000 rw- /opt/rubies/3.2.0/lib/libruby.3.2.dylib

1051e8000-1051ec000 --- /opt/rubies/3.2.0/lib/libruby.3.2.dylib

1051ec000-105290000 rw- /opt/rubies/3.2.0/lib/libruby.3.2.dylib

105290000-105294000 --- /opt/rubies/3.2.0/lib/libruby.3.2.dylib

105294000-105338000 rw- /opt/rubies/3.2.0/lib/libruby.3.2.dylib

105338000-10533c000 --- /opt/rubies/3.2.0/lib/libruby.3.2.dylib

10533c000-1053e0000 rw- /opt/rubies/3.2.0/lib/libruby.3.2.dylib

1053e0000-1053e4000 --- /opt/rubies/3.2.0/lib/libruby.3.2.dylib

1053e4000-105488000 rw- /opt/rubies/3.2.0/lib/libruby.3.2.dylib

105488000-10548c000 --- /opt/rubies/3.2.0/lib/libruby.3.2.dylib

10548c000-105530000 rw- /opt/rubies/3.2.0/lib/libruby.3.2.dylib

105530000-105534000 --- /opt/rubies/3.2.0/lib/libruby.3.2.dylib

105534000-1055d8000 rw- /opt/rubies/3.2.0/lib/libruby.3.2.dylib

1055d8000-105cd8000 r-- /opt/rubies/3.2.0/lib/libruby.3.2.dylib

113000000-113800000 rw-

118000000-118800000 rw-

118800000-119000000 rw-

119000000-119800000 rw-

119800000-11a000000 rw-

11a000000-11a800000 rw-

11a800000-11b000000 rw-

11b000000-11b800000 rw-

11b800000-11c000000 rw-

11c000000-11c800000 rw-

11c800000-11d000000 rw-

11d000000-11d800000 rw-

11d800000-11e000000 rw-

11e000000-11e800000 rw-

11e800000-11f000000 rw-

11f000000-11f800000 rw-

11f800000-120000000 rw-

128000000-128800000 rw-

128800000-129000000 rw-

129000000-129800000 rw-

129800000-12a000000 rw-

12a000000-12a800000 rw-

12a800000-12b000000 rw-

12b000000-12b800000 rw-

12b800000-12c000000 rw-

12c000000-12c800000 rw-

12c800000-12d000000 rw-

12d000000-12d800000 rw-

12d800000-12e000000 rw-

12e000000-12e800000 rw-

12e800000-12f000000 rw-

12f000000-12f800000 rw-

12f800000-130000000 rw-

133000000-133800000 rw-

138000000-138800000 rw-
138800000-139000000 rw-

139000000-139800000 rw-

139800000-13a000000 rw-

13a000000-13a800000 rw-

13a800000-13b000000 rw-

13b000000-13b800000 rw-

13b800000-13c000000 rw-

13c000000-13c800000 rw-

13c800000-13d000000 rw-

13d000000-13d800000 rw-

13d800000-13e000000 rw-

13e000000-13e800000 rw-

13e800000-13f000000 rw-

13f000000-13f800000 rw-

13f800000-140000000 rw-

142e00000-142e04000 rw-

142f00000-143000000 rw-

143000000-143800000 rw-

143800000-144000000 rw-

144000000-146000000 rw-

146000000-146800000 rw-

146800000-146900000 rw-

146900000-146a00000 rw-

146a00000-146b00000 rw-

146b00000-146c00000 rw-

148000000-148800000 rw-

148800000-149000000 rw-

149000000-149800000 rw-

149800000-14a000000 rw-

14a000000-14a800000 rw-

14a800000-14b000000 rw-

14b000000-14b800000 rw-

14b800000-14c000000 rw-

14c000000-14c800000 rw-

14c800000-14d000000 rw-

14d000000-14d800000 rw-

14d800000-14e000000 rw-

14e000000-14e800000 rw-

14e800000-14f000000 rw-

14f000000-14f800000 rw-

14f800000-150000000 rw-

152e00000-152f00000 rw-

152f00000-153000000 rw-

153000000-153800000 rw-

153800000-154000000 rw-

154000000-154100000 rw-

158000000-158800000 rw-

158800000-159000000 rw-

159000000-159800000 rw-

159800000-15a000000 rw-

15a000000-15a800000 rw-

15a800000-15b000000 rw-

15b000000-15b800000 rw-

15b800000-15c000000 rw-

15c000000-15c800000 rw-

15c800000-15d000000 rw-

15d000000-15d800000 rw-

15d800000-15e000000 rw-

15e000000-15e800000 rw-

15e800000-15f000000 rw-

15f000000-15f800000 rw-

15f800000-160000000 rw-

169bc4000-16d3c8000 ---

16d3c8000-16dbc4000 rw-

16dbc4000-16dbc8000 ---

16dbc8000-16dc50000 rw-

180000000-1ee000000 r--
1ee000000-1ef794000 r--

1ef794000-1ef7bc000 rw-

1ef7bc000-1f0000000 rw-

1f0000000-1f1abc000 r--

1f1abc000-1f3690000 rw-

1f3690000-1f6b50000 r--

1f6b50000-1f8000000 r--

1f8000000-22a000000 r--

22a000000-22a8cc000 r--

22a8cc000-22c000000 rw-

22c000000-22cb34000 r--

22cb34000-22e194000 rw-

22e194000-22f5a0000 r--

22f5a0000-230000000 r--

230000000-280000000 r--

fc0000000-1000000000 ---

1000000000-7000000000 ---

[IMPORTANT]

Don't forget to include the Crash Report log file under

DiagnosticReports directory in bug reports.

Associated revisions

Revision 837ef8911c638c3e2bdb6af710de7c1fac7b5f90 - 01/04/2023 07:59 PM - peterzhu2118 (Peter Zhu)

Fix crash in TracePoint c_call for removed method

trace_arg->id is the ID of the original method of an aliased method. If

the original method is removed, then the lookup will fail. We should use

trace_arg->called_id instead, which is the ID of the aliased method.

Fixes [Bug #19305]

Revision 837ef8911c638c3e2bdb6af710de7c1fac7b5f90 - 01/04/2023 07:59 PM - peterzhu2118 (Peter Zhu)

Fix crash in TracePoint c_call for removed method

trace_arg->id is the ID of the original method of an aliased method. If

the original method is removed, then the lookup will fail. We should use

trace_arg->called_id instead, which is the ID of the aliased method.

Fixes [Bug #19305]

Revision 837ef891 - 01/04/2023 07:59 PM - peterzhu2118 (Peter Zhu)

Fix crash in TracePoint c_call for removed method

trace_arg->id is the ID of the original method of an aliased method. If

the original method is removed, then the lookup will fail. We should use

trace_arg->called_id instead, which is the ID of the aliased method.

Fixes [Bug #19305]

Revision d7fb4629b4058eb86be03760e6b9f1f272e44147 - 01/18/2023 11:15 AM - naruse (Yui NARUSE)

merge revision(s) 837ef8911c638c3e2bdb6af710de7c1fac7b5f90: [Backport #19305]

    Fix crash in TracePoint c_call for removed method

    trace_arg->id is the ID of the original method of an aliased method. If

    the original method is removed, then the lookup will fail. We should use

    trace_arg->called_id instead, which is the ID of the aliased method.

    Fixes [Bug #19305]

    ---

     test/ruby/test_settracefunc.rb | 23 +++++++++++++++++++++++

     vm_trace.c                     |  2 +-

     2 files changed, 24 insertions(+), 1 deletion(-)

Revision d7fb4629b4058eb86be03760e6b9f1f272e44147 - 01/18/2023 11:15 AM - naruse (Yui NARUSE)

merge revision(s) 837ef8911c638c3e2bdb6af710de7c1fac7b5f90: [Backport #19305]
    Fix crash in TracePoint c_call for removed method

    trace_arg->id is the ID of the original method of an aliased method. If

    the original method is removed, then the lookup will fail. We should use

    trace_arg->called_id instead, which is the ID of the aliased method.

    Fixes [Bug #19305]

    ---

     test/ruby/test_settracefunc.rb | 23 +++++++++++++++++++++++

     vm_trace.c                     |  2 +-

     2 files changed, 24 insertions(+), 1 deletion(-)

Revision d7fb4629 - 01/18/2023 11:15 AM - naruse (Yui NARUSE)

merge revision(s) 837ef8911c638c3e2bdb6af710de7c1fac7b5f90: [Backport #19305]

    Fix crash in TracePoint c_call for removed method

    trace_arg->id is the ID of the original method of an aliased method. If

    the original method is removed, then the lookup will fail. We should use

    trace_arg->called_id instead, which is the ID of the aliased method.

    Fixes [Bug #19305]

    ---

     test/ruby/test_settracefunc.rb | 23 +++++++++++++++++++++++

     vm_trace.c                     |  2 +-

     2 files changed, 24 insertions(+), 1 deletion(-)

Revision eba3f787cbd38acf60fff6bdb450aacfc2e9c3a1 - 03/21/2023 03:00 AM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 837ef8911c638c3e2bdb6af710de7c1fac7b5f90: [Backport #19305]

    Fix crash in TracePoint c_call for removed method

    trace_arg->id is the ID of the original method of an aliased method. If

    the original method is removed, then the lookup will fail. We should use

    trace_arg->called_id instead, which is the ID of the aliased method.

    Fixes [Bug #19305]

    ---

     test/ruby/test_settracefunc.rb | 23 +++++++++++++++++++++++

     vm_trace.c                     |  2 +-

     2 files changed, 24 insertions(+), 1 deletion(-)

Revision eba3f787cbd38acf60fff6bdb450aacfc2e9c3a1 - 03/21/2023 03:00 AM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 837ef8911c638c3e2bdb6af710de7c1fac7b5f90: [Backport #19305]

    Fix crash in TracePoint c_call for removed method

    trace_arg->id is the ID of the original method of an aliased method. If

    the original method is removed, then the lookup will fail. We should use

    trace_arg->called_id instead, which is the ID of the aliased method.

    Fixes [Bug #19305]

    ---

     test/ruby/test_settracefunc.rb | 23 +++++++++++++++++++++++

     vm_trace.c                     |  2 +-

     2 files changed, 24 insertions(+), 1 deletion(-)

Revision eba3f787 - 03/21/2023 03:00 AM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 837ef8911c638c3e2bdb6af710de7c1fac7b5f90: [Backport #19305]

    Fix crash in TracePoint c_call for removed method

    trace_arg->id is the ID of the original method of an aliased method. If

    the original method is removed, then the lookup will fail. We should use

    trace_arg->called_id instead, which is the ID of the aliased method.

    Fixes [Bug #19305]

    ---

     test/ruby/test_settracefunc.rb | 23 +++++++++++++++++++++++

     vm_trace.c                     |  2 +-

     2 files changed, 24 insertions(+), 1 deletion(-)
History

#1 - 01/04/2023 07:11 PM - peterzhu2118 (Peter Zhu)

- Backport changed from 2.7: UNKNOWN, 3.0: UNKNOWN, 3.1: UNKNOWN, 3.2: UNKNOWN to 2.7: DONTNEED, 3.0: DONTNEED, 3.1:

REQUIRED, 3.2: REQUIRED

Thank you for reporting this bug. I have a fix in this PR: https://github.com/ruby/ruby/pull/7064

#2 - 01/04/2023 11:06 PM - peterzhu2118 (Peter Zhu)

- Status changed from Open to Closed

Applied in changeset git|837ef8911c638c3e2bdb6af710de7c1fac7b5f90.

Fix crash in TracePoint c_call for removed method

trace_arg->id is the ID of the original method of an aliased method. If

the original method is removed, then the lookup will fail. We should use

trace_arg->called_id instead, which is the ID of the aliased method.

Fixes [Bug #19305]

#3 - 01/04/2023 11:36 PM - st0012 (Stan Lo)

Thank you so much for the fix :-)

#4 - 01/19/2023 12:29 AM - naruse (Yui NARUSE)

- Backport changed from 2.7: DONTNEED, 3.0: DONTNEED, 3.1: REQUIRED, 3.2: REQUIRED to 2.7: DONTNEED, 3.0: DONTNEED, 3.1:

REQUIRED, 3.2: DONE

ruby_3_2 d7fb4629b4058eb86be03760e6b9f1f272e44147 merged revision(s) 837ef8911c638c3e2bdb6af710de7c1fac7b5f90.

#5 - 03/21/2023 03:45 AM - nagachika (Tomoyuki Chikanaga)

- Backport changed from 2.7: DONTNEED, 3.0: DONTNEED, 3.1: REQUIRED, 3.2: DONE to 2.7: DONTNEED, 3.0: DONTNEED, 3.1: DONE, 3.2:

DONE

ruby_3_1 eba3f787cbd38acf60fff6bdb450aacfc2e9c3a1 merged revision(s) 837ef8911c638c3e2bdb6af710de7c1fac7b5f90.
